> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/changelogs/version-5/v5-1-0.md).

# Version 5.1.0 Changelog (2019-06-05)

World's #1 PDF SDK Library for Web, Mobile, Server, Desktop

## New

* Added a new instantiation function that returns promise when viewer is ready.
* Added new [constructor options](https://sdk.apryse.com/api/web/global.html#WebViewer__anchor): preloadWorker and extension.
* [signatureWidgetAnnotation.createSignHereElement](/web/digital-signature/interacting-with-signature-field.md)
* Added a warning message if samples are ran from file system
* Added support for auto-growing FreeText annotations.
* Added shouldDrawOverAnnotation option in [setWatermark](https://sdk.apryse.com/api/web/Core.DocumentViewer.html#setWatermark__anchor)
* Added [showErrorMessage](https://sdk.apryse.com/api/web/WebViewerInstance.html#showErrorMessage__anchor) API
* Added setAllowCreationOverAnnotation property on [polyline](https://sdk.apryse.com/api/web/Core.Tools.PolylineCreateTool.html) and [polygon](https://sdk.apryse.com/api/web/Core.Tools.PolygonCreateTool.html) tools
* Added [realtime collaboration sample](https://github.com/PDFTron/webviewer-realtime-collaboration-sqlite3-sample/) using WebSocket
* Added a new [FormBuilder sample](/web/get-started/guides/samples/full-apis.md#viewerformbuilder) to add form fields to a document in WebViewer.
* Added setLoadAnnotationsFromVisiblePages to optionally only load annotations from visible pages.
* Added support for setting readonly and required fields with embedded JavaScript.
* Added API [Annotations.Forms.EmbeddedJS.update](https://sdk.apryse.com/api/web/Core.Annotations.Forms.EmbeddedJS.html#update__anchor) to override the default behavior of Embedded JavaScript functions.

## Updates

* Updated sticky, polygon and polyine not to start drawing when clicked on top of another annotation
* Updated Marquee zoom tool to support zoom out
* Updated line annotation with a measure dictionary to be able to render custom font size, font color
* Updated pre-render and caching level for iOS

## Fixes

* Fixed issue with loading link annotations from Office documents.
* Fixed issue with loading a small number of linearized documents.
* Fixed issue where watermark didn't show up when downloading a document from WebViewer Server.
* Fixed issue with StreamingPartRetriever loading encrypted XOD files.
* Fixed issue with annotation replies not showing up if reply was imported separately before the parent.
* Fixed issue where readonly single line text fields would wrap when they shouldn't.
* Fixed issue with single points not being created from a tap using the freehand tool.
* Fixed issues with the AFNumber\_Keystroke function not matching the behavior of other PDF viewers.
* Fixed issue where permissionCheckCallback setting wasn't applied for notes initially
* Fixed issue where position sort strategy wasn't taking the orientation into account
* Fixed issue where downloadPdf API doesn't allow downloading office files


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/web/changelogs/version-5/v5-1-0.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
